
# Class: AuCanvas

The base class for the [`Canvas`](auwidgetcanvas.md) widget.

## Hierarchy

  ↳ [AuBaseWidget](aubasewidget.md)

  ↳ **AuCanvas**

  ↳ [AuWidgetCanvas](auwidgetcanvas.md)

## Implements

* [IWidget](../interfaces/iwidget.md)

## Index

### Properties

* [params](aucanvas.md#params)

### Methods

* [checkInitDependenciesWidgets](aucanvas.md#checkinitdependencieswidgets)
* [getCanvasItemModel](aucanvas.md#getcanvasitemmodel)
* [resetPreloaderState](aucanvas.md#resetpreloaderstate)
* [showPreloader](aucanvas.md#showpreloader)
* [showToast](aucanvas.md#showtoast)

## Properties

###  params

• **params**: *any*

*Inherited from [AuBaseWidget](aubasewidget.md).[params](aubasewidget.md#params)*

Compiled widget configuration.

## Methods

###  checkInitDependenciesWidgets

▸ **checkInitDependenciesWidgets**(): *string[]*

*Inherited from [AuBaseWidget](aubasewidget.md).[checkInitDependenciesWidgets](aubasewidget.md#checkinitdependencieswidgets)*

Returns an array of widget names, due to which the current widget cannot receive parameters.

**Returns:** *string[]*

___

###  getCanvasItemModel

▸ **getCanvasItemModel**(`changeObject`: [ItemChangeObject](../interfaces/itemchangeobject.md)): *Promise‹[CanvasItemChanges](canvasitemchanges.md)›*

Gets the object model of the elements on the canvas.
 @ignore

**Parameters:**

Name | Type |
------ | ------ |
`changeObject` | [ItemChangeObject](../interfaces/itemchangeobject.md) |

**Returns:** *Promise‹[CanvasItemChanges](canvasitemchanges.md)›*

___

###  resetPreloaderState

▸ **resetPreloaderState**(): *void*

*Inherited from [AuBaseWidget](aubasewidget.md).[resetPreloaderState](aubasewidget.md#resetpreloaderstate)*

**Returns:** *void*

___

###  showPreloader

▸ **showPreloader**(`isPreload`: boolean, `message`: string | string[], `timeout`: number): *void*

*Inherited from [AuBaseWidget](aubasewidget.md).[showPreloader](aubasewidget.md#showpreloader)*

Shows a preloader.

```
"onClick": [
  "{{#function main.showPreloader(true, 'Creating print files...')}}",
  "{{#function $['editor'].getHiResImages(800,800)}}",
  "{{#function main.showPreloader(false)}}"
]
```

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`isPreload` | boolean | - | If `true`, enables the preloader. |
`message` | string &#124; string[] |  [''] | A text message that appears next to the preloader.  |
`timeout` | number | 5 | - |

**Returns:** *void*

___

###  showToast

▸ **showToast**(`data?`: string, `duration?`: number): *void*

*Inherited from [AuBaseWidget](aubasewidget.md).[showToast](aubasewidget.md#showtoast)*

Shows a toast.

```
return editor.loadUserInfo(data)
    .catch(err => {
        this.widget.showToast("Error: Invalid data");
        console.log(err);
    });
```

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`data?` | string | A string message to display in the toast. |
`duration?` | number | Defines how long to show the toast for.  |

**Returns:** *void*
